VTK: vtkStreamingTessellator Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
vtkStreamingTessellator Class Reference

An algorithm that refines an initial simplicial tessellation using edge subdivision. More...

`#include <vtkStreamingTessellator.h>`

Inheritance diagram for vtkStreamingTessellator:
[legend]
Collaboration diagram for vtkStreamingTessellator:
[legend]

## Public Types
enum | { MaxFieldSize = 18 }
typedef vtkObject | Superclass
typedef void(* | VertexProcessorFunction) (const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)
typedef void(* | EdgeProcessorFunction) (const double *, const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)
typedef void(* | TriangleProcessorFunction) (const double *, const double *, const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)
typedef void(* | TetrahedronProcessorFunction) (const double *, const double *, const double *, const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkStreamingTessellator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual const vtkEdgeSubdivisionCriterion * | GetSubdivisionAlgorithm () const
virtual void | SetTetrahedronCallback (TetrahedronProcessorFunction)
| Get/Set the function called for each output tetrahedron (3-facet). More...
virtual TetrahedronProcessorFunction | GetTetrahedronCallback () const
| Get/Set the function called for each output tetrahedron (3-facet). More...
virtual void | SetTriangleCallback (TriangleProcessorFunction)
| Get/Set the function called for each output triangle (2-facet). More...
virtual TriangleProcessorFunction | GetTriangleCallback () const
| Get/Set the function called for each output triangle (2-facet). More...
virtual void | SetEdgeCallback (EdgeProcessorFunction)
| Get/Set the function called for each output line segment (1-facet). More...
virtual EdgeProcessorFunction | GetEdgeCallback () const
| Get/Set the function called for each output line segment (1-facet). More...
virtual void | SetVertexCallback (VertexProcessorFunction)
| Get/Set the function called for each output line segment (1-facet). More...
virtual VertexProcessorFunction | GetVertexCallback () const
| Get/Set the function called for each output line segment (1-facet). More...
virtual void | SetPrivateData (void *Private)
| Get/Set a void pointer passed to the triangle and edge output functions. More...
virtual void * | GetPrivateData () const
| Get/Set a void pointer passed to the triangle and edge output functions. More...
virtual void | SetConstPrivateData (const void *ConstPrivate)
| Get/Set a constant void pointer passed to the simplex output functions. More...
virtual const void * | GetConstPrivateData () const
| Get/Set a constant void pointer passed to the simplex output functions. More...
virtual void | SetSubdivisionAlgorithm (vtkEdgeSubdivisionCriterion *)
| Get/Set the algorithm used to determine whether an edge should be subdivided or left as-is. More...
virtual vtkEdgeSubdivisionCriterion * | GetSubdivisionAlgorithm ()
| Get/Set the algorithm used to determine whether an edge should be subdivided or left as-is. More...
virtual void | SetEmbeddingDimension (int k, int d)
| Get/Set the number of parameter-space coordinates associated with each input and output point. More...
int | GetEmbeddingDimension (int k) const
| Get/Set the number of parameter-space coordinates associated with each input and output point. More...
virtual void | SetFieldSize (int k, int s)
| Get/Set the number of field value coordinates associated with each input and output point. More...
int | GetFieldSize (int k) const
| Get/Set the number of field value coordinates associated with each input and output point. More...
virtual void | SetMaximumNumberOfSubdivisions (int num_subdiv_in)
| Get/Set the maximum number of subdivisions that may occur. More...
int | GetMaximumNumberOfSubdivisions ()
| Get/Set the maximum number of subdivisions that may occur. More...
void | AdaptivelySample3FacetLinear (double *v0, double *v1, double *v2, double *v3) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | AdaptivelySample2FacetLinear (double *v0, double *v1, double *v2) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | AdaptivelySample1FacetLinear (double *v0, double *v1) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | AdaptivelySample3Facet (double *v0, double *v1, double *v2, double *v3) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | AdaptivelySample2Facet (double *v0, double *v1, double *v2) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | AdaptivelySample1Facet (double *v0, double *v1) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | AdaptivelySample0Facet (double *v0) const
| This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached. More...
void | ResetCounts ()
| Reset/access the histogram of subdivision cases encountered. More...
vtkIdType | GetCaseCount (int c)
| Reset/access the histogram of subdivision cases encountered. More...
vtkIdType | GetSubcaseCount (int casenum, int sub)
| Reset/access the histogram of subdivision cases encountered. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkStreamingTessellator * | SafeDownCast (vtkObjectBase *o)
static vtkStreamingTessellator * | New ()
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkStreamingTessellator ()
| ~vtkStreamingTessellator () override
void | AdaptivelySample3Facet (double *v0, double *v1, double *v2, double *v3, int maxDepth) const
void | AdaptivelySample2Facet (double *v0, double *v1, double *v2, int maxDepth, int move=7) const
void | AdaptivelySample1Facet (double *v0, double *v1, int maxDepth) const
int | BestTets (int *, double **, int, int) const
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
void * | PrivateData
const void * | ConstPrivateData
vtkEdgeSubdivisionCriterion * | Algorithm
VertexProcessorFunction | Callback0
EdgeProcessorFunction | Callback1
TriangleProcessorFunction | Callback2
TetrahedronProcessorFunction | Callback3
int | PointDimension [4]
| PointDimension is the length of each `double*` array associated with each point passed to a subdivision algorithm: PointDimension[i] = 3 + EmbeddingDimension[i] + FieldSize[i] We store this instead of FieldSize for speed. More...
int | EmbeddingDimension [4]
| The parametric dimension of each point passed to the subdivision algorithm. More...
int | MaximumNumberOfSubdivisions
| The number of subdivisions allowed. More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Static Protected Attributes
static int | EdgeCodesToCaseCodesPlusPermutation [64][2]
static vtkIdType | PermutationsFromIndex [24][14]
static vtkIdType | TetrahedralDecompositions []

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

An algorithm that refines an initial simplicial tessellation using edge subdivision.

This class is a simple algorithm that takes a single starting simplex – a tetrahedron, triangle, or line segment – and calls a function you pass it with (possibly many times) tetrahedra, triangles, or lines adaptively sampled from the one you specified. It uses an algorithm you specify to control the level of adaptivity.

This class does not create vtkUnstructuredGrid output because it is intended for use in mappers as well as filters. Instead, it calls the registered function with simplices as they are created.

The subdivision algorithm should change the vertex coordinates (it must change both geometric and, if desired, parametric coordinates) of the midpoint. These coordinates need not be changed unless the EvaluateLocationAndFields() member returns true. The vtkStreamingTessellator itself has no way of creating a more accurate midpoint vertex.

Here's how to use this class:

- Call AdaptivelySample1Facet, AdaptivelySample2Facet, or AdaptivelySample3Facet, with an edge, triangle, or tetrahedron you want tessellated.
- The adaptive tessellator classifies each edge by passing the midpoint values to the vtkEdgeSubdivisionCriterion.
- After each edge is classified, the tessellator subdivides edges as required until the subdivision criterion is satisfied or the maximum subdivision depth has been reached.
- Edges, triangles, or tetrahedra connecting the vertices generated by the subdivision algorithm are processed by calling the user-defined callback functions (set with SetTetrahedronCallback(), SetTriangleCallback(), or SetEdgeCallback() ).

Warning
  Note that the vertices passed to AdaptivelySample3Facet, AdaptivelySample2Facet, or AdaptivelySample1Facet must be at least 6, 5, or 4 entries long, respectively! This is because the <r,s,t>, <r,s>, or <r> parametric coordinates of the vertices are maintained as the facet is subdivided. This information is often required by the subdivision algorithm in order to compute an error metric. You may change the number of parametric coordinates associated with each vertex using vtkStreamingTessellator::SetEmbeddingDimension().

Interpolating Field Values:
  If you wish, you may also use `vtkStreamingTessellator` to interpolate field values at newly created vertices. Interpolated field values are stored just beyond the parametric coordinates associated with a vertex. They will always be `double` values; it does not make sense to interpolate a boolean or string value and your output and subdivision subroutines may always cast to a `float` or use `floor()` to truncate an interpolated value to an integer.

See also
  vtkEdgeSubdivisionCriterion

Tests:
  vtkStreamingTessellator (Tests)

Definition at line 78 of file vtkStreamingTessellator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkStreamingTessellator::Superclass

Definition at line 81 of file vtkStreamingTessellator.h.

## ◆ VertexProcessorFunction

typedef void(* vtkStreamingTessellator::VertexProcessorFunction) (const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)

Definition at line 85 of file vtkStreamingTessellator.h.

## ◆ EdgeProcessorFunction

typedef void(* vtkStreamingTessellator::EdgeProcessorFunction) (const double *, const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)

Definition at line 87 of file vtkStreamingTessellator.h.

## ◆ TriangleProcessorFunction

typedef void(* vtkStreamingTessellator::TriangleProcessorFunction) (const double *, const double *, const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)

Definition at line 89 of file vtkStreamingTessellator.h.

## ◆ TetrahedronProcessorFunction

typedef void(* vtkStreamingTessellator::TetrahedronProcessorFunction) (const double *, const double *, const double *, const double *, vtkEdgeSubdivisionCriterion *, void *, const void *)

Definition at line 91 of file vtkStreamingTessellator.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
MaxFieldSize |

Definition at line 94 of file vtkStreamingTessellator.h.

## Constructor & Destructor Documentation

## ◆ vtkStreamingTessellator()

vtkStreamingTessellator::vtkStreamingTessellator | ( |  | ) |
| protected

## ◆ ~vtkStreamingTessellator()

vtkStreamingTessellator::~vtkStreamingTessellator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkStreamingTessellator::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkStreamingTessellator::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkStreamingTessellator* vtkStreamingTessellator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkStreamingTessellator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkStreamingTessellator* vtkStreamingTessellator::NewInstance | ( |  | ) | const

## ◆ New()

static vtkStreamingTessellator* vtkStreamingTessellator::New | ( |  | ) |
| static

## ◆ PrintSelf()

void vtkStreamingTessellator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ SetTetrahedronCallback()

virtual void vtkStreamingTessellator::SetTetrahedronCallback | ( | TetrahedronProcessorFunction |  | ) |
| virtual

Get/Set the function called for each output tetrahedron (3-facet).

## ◆ GetTetrahedronCallback()

virtual TetrahedronProcessorFunction vtkStreamingTessellator::GetTetrahedronCallback | ( |  | ) | const
| virtual

Get/Set the function called for each output tetrahedron (3-facet).

## ◆ SetTriangleCallback()

virtual void vtkStreamingTessellator::SetTriangleCallback | ( | TriangleProcessorFunction |  | ) |
| virtual

Get/Set the function called for each output triangle (2-facet).

## ◆ GetTriangleCallback()

virtual TriangleProcessorFunction vtkStreamingTessellator::GetTriangleCallback | ( |  | ) | const
| virtual

Get/Set the function called for each output triangle (2-facet).

## ◆ SetEdgeCallback()

virtual void vtkStreamingTessellator::SetEdgeCallback | ( | EdgeProcessorFunction |  | ) |
| virtual

Get/Set the function called for each output line segment (1-facet).

## ◆ GetEdgeCallback()

virtual EdgeProcessorFunction vtkStreamingTessellator::GetEdgeCallback | ( |  | ) | const
| virtual

Get/Set the function called for each output line segment (1-facet).

## ◆ SetVertexCallback()

virtual void vtkStreamingTessellator::SetVertexCallback | ( | VertexProcessorFunction |  | ) |
| virtual

Get/Set the function called for each output line segment (1-facet).

## ◆ GetVertexCallback()

virtual VertexProcessorFunction vtkStreamingTessellator::GetVertexCallback | ( |  | ) | const
| virtual

Get/Set the function called for each output line segment (1-facet).

## ◆ SetPrivateData()

virtual void vtkStreamingTessellator::SetPrivateData | ( | void * | Private | ) |
| virtual

Get/Set a void pointer passed to the triangle and edge output functions.

## ◆ GetPrivateData()

virtual void* vtkStreamingTessellator::GetPrivateData | ( |  | ) | const
| virtual

Get/Set a void pointer passed to the triangle and edge output functions.

## ◆ SetConstPrivateData()

virtual void vtkStreamingTessellator::SetConstPrivateData | ( | const void * | ConstPrivate | ) |
| virtual

Get/Set a constant void pointer passed to the simplex output functions.

## ◆ GetConstPrivateData()

virtual const void* vtkStreamingTessellator::GetConstPrivateData | ( |  | ) | const
| virtual

Get/Set a constant void pointer passed to the simplex output functions.

## ◆ SetSubdivisionAlgorithm()

virtual void vtkStreamingTessellator::SetSubdivisionAlgorithm | ( | vtkEdgeSubdivisionCriterion * |  | ) |
| virtual

Get/Set the algorithm used to determine whether an edge should be subdivided or left as-is.

This is used once for each call to AdaptivelySample1Facet (which is recursive and will call itself resulting in additional edges to be checked) or three times for each call to AdaptivelySample2Facet (also recursive).

## ◆ GetSubdivisionAlgorithm() [1/2]

virtual vtkEdgeSubdivisionCriterion* vtkStreamingTessellator::GetSubdivisionAlgorithm | ( |  | ) |
| virtual

Get/Set the algorithm used to determine whether an edge should be subdivided or left as-is.

This is used once for each call to AdaptivelySample1Facet (which is recursive and will call itself resulting in additional edges to be checked) or three times for each call to AdaptivelySample2Facet (also recursive).

## ◆ GetSubdivisionAlgorithm() [2/2]

virtual const vtkEdgeSubdivisionCriterion* vtkStreamingTessellator::GetSubdivisionAlgorithm | ( |  | ) | const
| virtual

## ◆ SetEmbeddingDimension()

virtual void vtkStreamingTessellator::SetEmbeddingDimension | ( | int | k,
|  | int | d
| ) |  |
| virtual

Get/Set the number of parameter-space coordinates associated with each input and output point.

The default is k for k -facets. You may specify a different dimension, d, for each type of k -facet to be processed. For example, `SetEmbeddingDimension`( `2`, `3` ) would associate r, s, and t coordinates with each input and output point generated by `AdaptivelySample2Facet` but does not say anything about input or output points generated by `AdaptivelySample1Facet`. Call `SetEmbeddingDimension`( `-1`, d ) to specify the same dimension for all possible k values. d may not exceed 8, as that would be plain silly.

## ◆ GetEmbeddingDimension()

int vtkStreamingTessellator::GetEmbeddingDimension | ( | int | k | ) | const
| inline

Get/Set the number of parameter-space coordinates associated with each input and output point.

The default is k for k -facets. You may specify a different dimension, d, for each type of k -facet to be processed. For example, `SetEmbeddingDimension`( `2`, `3` ) would associate r, s, and t coordinates with each input and output point generated by `AdaptivelySample2Facet` but does not say anything about input or output points generated by `AdaptivelySample1Facet`. Call `SetEmbeddingDimension`( `-1`, d ) to specify the same dimension for all possible k values. d may not exceed 8, as that would be plain silly.

Definition at line 369 of file vtkStreamingTessellator.h.

## ◆ SetFieldSize()

virtual void vtkStreamingTessellator::SetFieldSize | ( | int | k,
|  | int | s
| ) |  |
| virtual

Get/Set the number of field value coordinates associated with each input and output point.

The default is 0; no field values are interpolated. You may specify a different size, s, for each type of k -facet to be processed. For example, `SetFieldSize`( `2`, `3` ) would associate 3 field value coordinates with each input and output point of an `AdaptivelySample2Facet` call, but does not say anything about input or output points of `AdaptivelySample1Facet`. Call `SetFieldSize`( `-1`, s ) to specify the same dimension for all possible k values. s may not exceed vtkStreamingTessellator::MaxFieldSize. This is a compile-time constant that defaults to 18, which is large enough for a scalar, vector, tensor, normal, and texture coordinate to be included at each point.

Normally, you will not call SetFieldSize() directly; instead, subclasses of vtkEdgeSubdivisionCriterion, such as vtkShoeMeshSubdivisionAlgorithm, will call it for you.

In any event, setting FieldSize to a non-zero value means you must pass field values to the `AdaptivelySamplekFacet` routines; For example,

    * vtkStreamingTessellator* t = vtkStreamingTessellator::New();
    * t->SetFieldSize( 1, 3 );
    * t->SetEmbeddingDimension( 1, 1 ); // not really required, this is the default
    * double p0[3+1+3] = { x0, y0, z0, r0, fx0, fy0, fz0 };
    * double p1[3+1+3] = { x1, y1, z1, r1, fx1, fy1, fz1 };
    * t->AdaptivelySample1Facet( p0, p1 );
    *

This would adaptively sample an curve (1-facet) with geometry and a vector field at every output point on the curve.

## ◆ GetFieldSize()

int vtkStreamingTessellator::GetFieldSize | ( | int | k | ) | const
| inline

Get/Set the number of field value coordinates associated with each input and output point.

The default is 0; no field values are interpolated. You may specify a different size, s, for each type of k -facet to be processed. For example, `SetFieldSize`( `2`, `3` ) would associate 3 field value coordinates with each input and output point of an `AdaptivelySample2Facet` call, but does not say anything about input or output points of `AdaptivelySample1Facet`. Call `SetFieldSize`( `-1`, s ) to specify the same dimension for all possible k values. s may not exceed vtkStreamingTessellator::MaxFieldSize. This is a compile-time constant that defaults to 18, which is large enough for a scalar, vector, tensor, normal, and texture coordinate to be included at each point.

Normally, you will not call SetFieldSize() directly; instead, subclasses of vtkEdgeSubdivisionCriterion, such as vtkShoeMeshSubdivisionAlgorithm, will call it for you.

In any event, setting FieldSize to a non-zero value means you must pass field values to the `AdaptivelySamplekFacet` routines; For example,

    * vtkStreamingTessellator* t = vtkStreamingTessellator::New();
    * t->SetFieldSize( 1, 3 );
    * t->SetEmbeddingDimension( 1, 1 ); // not really required, this is the default
    * double p0[3+1+3] = { x0, y0, z0, r0, fx0, fy0, fz0 };
    * double p1[3+1+3] = { x1, y1, z1, r1, fx1, fy1, fz1 };
    * t->AdaptivelySample1Facet( p0, p1 );
    *

This would adaptively sample an curve (1-facet) with geometry and a vector field at every output point on the curve.

Definition at line 376 of file vtkStreamingTessellator.h.

## ◆ SetMaximumNumberOfSubdivisions()

virtual void vtkStreamingTessellator::SetMaximumNumberOfSubdivisions | ( | int | num_subdiv_in | ) |
| virtual

Get/Set the maximum number of subdivisions that may occur.

## ◆ GetMaximumNumberOfSubdivisions()

int vtkStreamingTessellator::GetMaximumNumberOfSubdivisions | ( |  | ) |
| inline

Get/Set the maximum number of subdivisions that may occur.

Definition at line 383 of file vtkStreamingTessellator.h.

## ◆ AdaptivelySample3FacetLinear()

void vtkStreamingTessellator::AdaptivelySample3FacetLinear | ( | double * | v0,
|  | double * | v1,
|  | double * | v2,
|  | double * | v3
| ) |  | const

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

## ◆ AdaptivelySample2FacetLinear()

void vtkStreamingTessellator::AdaptivelySample2FacetLinear | ( | double * | v0,
|  | double * | v1,
|  | double * | v2
| ) |  | const

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

## ◆ AdaptivelySample1FacetLinear()

void vtkStreamingTessellator::AdaptivelySample1FacetLinear | ( | double * | v0,
|  | double * | v1
| ) |  | const

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

## ◆ AdaptivelySample3Facet() [1/2]

void vtkStreamingTessellator::AdaptivelySample3Facet | ( | double * | v0,
|  | double * | v1,
|  | double * | v2,
|  | double * | v3
| ) |  | const
| inline

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

Definition at line 354 of file vtkStreamingTessellator.h.

## ◆ AdaptivelySample2Facet() [1/2]

void vtkStreamingTessellator::AdaptivelySample2Facet | ( | double * | v0,
|  | double * | v1,
|  | double * | v2
| ) |  | const
| inline

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

Definition at line 359 of file vtkStreamingTessellator.h.

## ◆ AdaptivelySample1Facet() [1/2]

void vtkStreamingTessellator::AdaptivelySample1Facet | ( | double * | v0,
|  | double * | v1
| ) |  | const
| inline

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

Definition at line 364 of file vtkStreamingTessellator.h.

## ◆ AdaptivelySample0Facet()

void vtkStreamingTessellator::AdaptivelySample0Facet | ( | double * | v0 | ) | const

This will adaptively subdivide the tetrahedron (3-facet), triangle (2-facet), or edge (1-facet) until the subdivision algorithm returns false for every edge or the maximum recursion depth is reached.

Use `SetMaximumNumberOfSubdivisions` to change the maximum recursion depth.

The AdaptivelySample0Facet method is provided as a convenience. Obviously, there is no way to adaptively subdivide a vertex. Instead the input vertex is passed unchanged to the output via a call to the registered VertexProcessorFunction callback.

.SECTION Warning This assumes that you have called SetSubdivisionAlgorithm(), SetEdgeCallback(), SetTriangleCallback(), and SetTetrahedronCallback() with valid values!

## ◆ ResetCounts()

void vtkStreamingTessellator::ResetCounts | ( |  | ) |
| inline

Reset/access the histogram of subdivision cases encountered.

The histogram may be used to examine coverage during testing as well as characterizing the tessellation algorithm's performance. You should call ResetCounts() once, at the beginning of a stream of tetrahedra. It must be called before AdaptivelySample3Facet() to prevent uninitialized memory reads.

These functions have no effect (and return 0) when PARAVIEW_DEBUG_TESSELLATOR has not been defined. By default, PARAVIEW_DEBUG_TESSELLATOR is not defined, and your code will be fast and efficient. Really!

Definition at line 266 of file vtkStreamingTessellator.h.

## ◆ GetCaseCount()

vtkIdType vtkStreamingTessellator::GetCaseCount | ( | int | c | ) |
| inline

Reset/access the histogram of subdivision cases encountered.

The histogram may be used to examine coverage during testing as well as characterizing the tessellation algorithm's performance. You should call ResetCounts() once, at the beginning of a stream of tetrahedra. It must be called before AdaptivelySample3Facet() to prevent uninitialized memory reads.

These functions have no effect (and return 0) when PARAVIEW_DEBUG_TESSELLATOR has not been defined. By default, PARAVIEW_DEBUG_TESSELLATOR is not defined, and your code will be fast and efficient. Really!

Definition at line 279 of file vtkStreamingTessellator.h.

## ◆ GetSubcaseCount()

vtkIdType vtkStreamingTessellator::GetSubcaseCount | ( | int | casenum,
|  | int | sub
| ) |  |
| inline

Reset/access the histogram of subdivision cases encountered.

The histogram may be used to examine coverage during testing as well as characterizing the tessellation algorithm's performance. You should call ResetCounts() once, at the beginning of a stream of tetrahedra. It must be called before AdaptivelySample3Facet() to prevent uninitialized memory reads.

These functions have no effect (and return 0) when PARAVIEW_DEBUG_TESSELLATOR has not been defined. By default, PARAVIEW_DEBUG_TESSELLATOR is not defined, and your code will be fast and efficient. Really!

Definition at line 288 of file vtkStreamingTessellator.h.

## ◆ AdaptivelySample3Facet() [2/2]

void vtkStreamingTessellator::AdaptivelySample3Facet | ( | double * | v0,
|  | double * | v1,
|  | double * | v2,
|  | double * | v3,
|  | int | maxDepth
| ) |  | const
| protected

## ◆ AdaptivelySample2Facet() [2/2]

void vtkStreamingTessellator::AdaptivelySample2Facet | ( | double * | v0,
|  | double * | v1,
|  | double * | v2,
|  | int | maxDepth,
|  | int | move = `7`
| ) |  | const
| protected

## ◆ AdaptivelySample1Facet() [2/2]

void vtkStreamingTessellator::AdaptivelySample1Facet | ( | double * | v0,
|  | double * | v1,
|  | int | maxDepth
| ) |  | const
| protected

## ◆ BestTets()

int vtkStreamingTessellator::BestTets | ( | int * | ,
|  | double ** | ,
|  | int | ,
|  | int |
| ) |  | const
| protected

## Member Data Documentation

## ◆ EdgeCodesToCaseCodesPlusPermutation

int vtkStreamingTessellator::EdgeCodesToCaseCodesPlusPermutation[64][2]
| staticprotected

Definition at line 301 of file vtkStreamingTessellator.h.

## ◆ PermutationsFromIndex

vtkIdType vtkStreamingTessellator::PermutationsFromIndex[24][14]
| staticprotected

Definition at line 302 of file vtkStreamingTessellator.h.

## ◆ TetrahedralDecompositions

vtkIdType vtkStreamingTessellator::TetrahedralDecompositions[]
| staticprotected

Definition at line 303 of file vtkStreamingTessellator.h.

## ◆ PrivateData

void* vtkStreamingTessellator::PrivateData
| protected

Definition at line 305 of file vtkStreamingTessellator.h.

## ◆ ConstPrivateData

const void* vtkStreamingTessellator::ConstPrivateData
| protected

Definition at line 306 of file vtkStreamingTessellator.h.

## ◆ Algorithm

vtkEdgeSubdivisionCriterion* vtkStreamingTessellator::Algorithm
| protected

Definition at line 307 of file vtkStreamingTessellator.h.

## ◆ Callback0

VertexProcessorFunction vtkStreamingTessellator::Callback0
| protected

Definition at line 309 of file vtkStreamingTessellator.h.

## ◆ Callback1

EdgeProcessorFunction vtkStreamingTessellator::Callback1
| protected

Definition at line 310 of file vtkStreamingTessellator.h.

## ◆ Callback2

TriangleProcessorFunction vtkStreamingTessellator::Callback2
| protected

Definition at line 311 of file vtkStreamingTessellator.h.

## ◆ Callback3

TetrahedronProcessorFunction vtkStreamingTessellator::Callback3
| protected

Definition at line 312 of file vtkStreamingTessellator.h.

## ◆ PointDimension

int vtkStreamingTessellator::PointDimension[4]
| protected

PointDimension is the length of each `double*` array associated with each point passed to a subdivision algorithm: PointDimension[i] = 3 + EmbeddingDimension[i] + FieldSize[i] We store this instead of FieldSize for speed.

Only entries 1 through 3 are used; you can't subdivide 0-facets (points). Well, maybe you can, but I can't!

Definition at line 326 of file vtkStreamingTessellator.h.

## ◆ EmbeddingDimension

int vtkStreamingTessellator::EmbeddingDimension[4]
| protected

The parametric dimension of each point passed to the subdivision algorithm.

Only entries 1 through 3 are used; you can't subdivide 0-facets (points). Well, maybe you can, but I can't!

Definition at line 333 of file vtkStreamingTessellator.h.

## ◆ MaximumNumberOfSubdivisions

int vtkStreamingTessellator::MaximumNumberOfSubdivisions
| protected

The number of subdivisions allowed.

Definition at line 338 of file vtkStreamingTessellator.h.

The documentation for this class was generated from the following file:

- Filters/Core/vtkStreamingTessellator.h